<template>
  <div class="bSelect_wrapper">
    <div
      class="bSelect"
      :class="{'bSelect-show': open}"
      @click="open = !open">
      <div>{{label}}</div>
      <img
        class="bSelect-icon"
        src="~/static/icons/corner-right-select.png"
        alt="">
    </div>
    <div
      class="bSelect_options"
      :style="{height: open ? height+'px' : 0+'px', borderWidth: open ? '1px' : '0px'}">
      <slot>
      </slot>
    </div>
  </div>
</template>

<script>
  export default {
    name: "BSelect",
    props: {
      value: {
        type: [String, Number]
      }
    },
    data() {
      return {
        label: '',
        open: false,
        height: 0,
      }
    },
    methods: {
      select(val) {
        this.open = false;
        this.$slots.default && this.$slots.default.forEach(item => {
          if (item.componentOptions.propsData.value === val) {
            this.label = item.componentOptions.propsData.label;
          }
        });
        this.$emit('change', val);
      }
    },
    mounted() {
      this.height = 0;
      this.$slots.default && this.$slots.default.forEach(item => {
        if (item.componentOptions.propsData.value === this.value) {
          this.label = item.componentOptions.propsData.label;
        }
        this.height += item.elm.clientHeight;
      });
    }
  }
</script>
<style
  lang="scss"
  scoped>
  .bSelect {
    display: flex;
    align-items: center;
    justify-content: space-around;
    padding: 5px 10px;
    background-color: #15233d;
    width: 100%;
    border: 1px solid #4f5a6e;
    border-radius: 8px;
    &_wrapper {
      display: inline-block;
      position: relative;
      width: 100px;
      color: #9ca6b0;
    }
    &_options {
      transition: height .1s ease-out;
      overflow: hidden;
      margin-top: 5px;
      position: absolute;
      left: 0px;
      border: 1px solid #4f5a6e;
      border-radius: 8px;
      width: 100%;
    }

    &-show {
      .bSelect-icon {
        transform: rotate(-90deg);
      }
    }
    &-icon {
      transition: transform .2s ease-out;
      margin-left: 10px;
      transform: rotate(90deg);
    }
  }
</style>
